import pyddl
import sys
import numpy as np

n = 10

pyddl.init()

rank = pyddl.rank()

initial_values = [x * (rank + 1)  for x in range(n)]

arr = np.array(initial_values, dtype=np.float32)

res, buf = pyddl.malloc(64, n * 4)

pyddl.memcpy_host_to_device(buf, arr)

pyddl.memsync()

pyddl.bcast(buf, n, pyddl.DDL_TYPE_FLOAT, 0)

pyddl.memcpy_device_to_host(arr, buf)

pyddl.memsync()

# Verify that the bcast produced the correct result
result = np.array_equal(np.array([x for x in range(n)], dtype=np.float32), arr)

if not result:
    sys.exit(1)

pyddl.finalize()

